-- Musically minded library :) (d)1998 CyrekSoft / Carl R. White

constant M_SOUND = 1 -- from graphics.e

constant 
    Octave = 12,
    Semitone = power(2, 1/Octave)

constant
    A_Diapazon = 440,--Hz
    Middle_C_Offset = -1*Octave + 2--Semitones
    -- Middle C is in fact Middle_C_Offset + 1.
    -- This is why it's an offset!

procedure sound(atom f) -- from graphics.e
    machine_proc(M_SOUND, f)
end procedure

global procedure dsound(atom frequency, atom delay)
    atom T
    
    if frequency > 16383 then
        frequency = 0
    end if
    
    sound(frequency)
    
    T = time() + (delay / 100)
    while time() < T do
        -- wait
    end while

end procedure

global procedure stopsound()
    sound(0)
end procedure

global procedure note(integer n, atom delay)
    
    dsound(A_Diapazon * power(Semitone, n+Middle_C_Offset), delay)

end procedure

global procedure endnote(integer n, atom delay)
    
    note(n, delay)
    stopsound()
    
end procedure

